unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, StdCtrls, voicerlibLib_TLB, ExtCtrls, ShellApi;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    lblDigitosvalidos: TLabel;
    txtDigitosvalidos: TEdit;
    lblTimeout: TLabel;
    txtTimeout: TEdit;
    lblMensagem: TLabel;
    lblTentativas: TLabel;
    lblMsgdeerro: TLabel;
    lblFrasetimeout: TLabel;
    txtMensagem: TEdit;
    txtTentativas: TEdit;
    txtMsgdeerro: TEdit;
    txtFrasetimeout: TEdit;
    GroupBox2: TGroupBox;
    cmdStart: TButton;
    cmdShutdown: TButton;
    memLog: TMemo;
    Panel2: TPanel;
    lblStatus: TLabel;
    cmdAtender: TButton;
    cmdReproduzirmenu: TButton;
    cmdInterromper: TButton;
    cmdDesligar: TButton;
    vlib: Tvoicerlib;
    cmdLimpaLog: TButton;
    Panel3: TPanel;
    lblStatus1: TLabel;
    lblStatus2: TLabel;
    btnEnable: TButton;
    btnDisable: TButton;
    Image1: TImage;
    Label1: TLabel;
    txtPorta: TEdit;
    LeiaMe: TButton;
    procedure cmdAtenderClick(Sender: TObject);
    procedure cmdDesligarClick(Sender: TObject);
    procedure cmdInterromperClick(Sender: TObject);
    procedure cmdReproduzirmenuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cmdStartClick(Sender: TObject);
    procedure cmdShutdownClick(Sender: TObject);
    procedure vLibRingDetected(ASender: TObject; Port: Smallint);
    procedure vLibPlayStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure vLibAfterPickup(ASender: TObject; Port: Smallint);
    procedure vLibBusyDetected(ASender: TObject; Port: Smallint);
    procedure LeiaMeClick(Sender: TObject);
    procedure vLibMenu(ASender: TObject; Port: Smallint;
      const OptionSelected: WideString; Status: Smallint);
    procedure cmdLimpaLogClick(Sender: TObject);
    procedure btnEnableClick(Sender: TObject);
    procedure btnDisableClick(Sender: TObject);
    procedure vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
  private
    { Private declarations }
    procedure GeraLog(nPorta: Integer; sMsg: String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  status: boolean;
  falando_lista: integer;
  nTotalPortas, nTotalPlacas, nPorta : Integer;
  sReturn    : array [0..255] of Char;

implementation

{$R *.DFM}

procedure TForm1.cmdAtenderClick(Sender: TObject);
var
  nRet: Integer;
begin
  //Atende a ligao
  nRet := vLib.PickUp(StrToInt(txtPorta.text),100);

  //Testa se atendeu corretamente
  if nRet = DG_EXIT_SUCCESS then
  begin
    cmdAtender.Enabled := False;
    cmdDesligar.Enabled := True;
    cmdInterromper.Enabled := True;
  end
  else
  begin
    lblStatus.Caption := 'Erro ao Atender';
    GeraLog(StrToInt(txtPorta.text),'Erro ao Atender...');
  end;

  //Especifica o formato de reproduo
  vLib.SetPlayFormat(StrToInt(txtPorta.text), ffWaveULaw);

end;

procedure TForm1.cmdDesligarClick(Sender: TObject);
var
  nRet: Integer;
begin
  //Desliga a ligao
  nRet:= vLib.HangUp(StrToInt(txtPorta.text));

  //Testa se desligou corretamente
  if nRet = DG_EXIT_SUCCESS then
  begin
    lblStatus.Caption := 'Desligou com sucesso';
    GeraLog(StrToInt(txtPorta.text),'Desligou com sucesso');
    cmdAtender.Enabled := True;
    cmdDesligar.Enabled := False;
  end
  else
  begin
    lblStatus.Caption := 'Erro ao Desligar';
    GeraLog(StrToInt(txtPorta.text),'Erro ao Desligar');
  end;
end;

procedure TForm1.cmdInterromperClick(Sender: TObject);
var
  nRet: Integer;
begin
  //Interrompe o menu
  nRet := vLib.MenuAbort(StrToInt(txtPorta.text));

  //Testa se interrompeu o menu corretamente
  if nRet = DG_EXIT_SUCCESS then
  begin
    cmdReproduzirmenu.Enabled := True;
    lblStatus.Caption:= 'Menu Interropido com sucesso!';
    GeraLog(StrToInt(txtPorta.text),'Menu Interropido com sucesso');
  end
  else
  begin
    lblStatus.Caption:= 'Erro ao interromper o menu. Cdigo: ' + inttostr(nRet);
    GeraLog(StrToInt(txtPorta.text),'Erro ao interromper o menu. Cdigo:' + inttostr(nRet));
  end;
end;

procedure TForm1.cmdReproduzirmenuClick(Sender: TObject);
var
  nRet: Integer;
begin
  falando_lista:=0;

  //Configura as opcoes de menu
  vLib.MenuErrorSettings(StrToInt(txtPorta.text), txtMsgdeerro.Text, strtoint(txtTentativas.text), txtFraseTimeout.Text);

  //Se estiver configurado '@' reproduz a lista de mensagem existente no PlayListAdd
  if txtMensagem.text='@' then
  begin
    vlib.PlayListClear(StrToInt(txtPorta.text));
    vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName) + 'menu.wav','',10);
  end;

  //Apaga o buffer de digitos da porta
  vlib.ClearDigits(StrToInt(txtPorta.text));
  //Reproduo do Menu
  nRet := vLib.MenuStart(StrToInt(txtPorta.text), txtMensagem.text,txtDigitosvalidos.Text ,
                         strtoint(txtTimeout.text), true, 0);

  //Testa a reproduo do menu
  if nRet = DG_EXIT_SUCCESS then
  begin
    lblStatus.Caption := 'Reproduzindo menu';
    GeraLog(StrToInt(txtPorta.text),'Reproduzindo menu..');
    status := True;
  end
  else
    lblStatus.Caption := 'Erro ao reproduzir o menu';
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet : Integer;
  cVersao : array[0..255] of Char;
begin
  txtMensagem.Text     := ExtractFilePath(Application.ExeName) + 'menu.wav';
  txtMsgdeerro.Text    := ExtractFilePath(Application.ExeName) + 'erro.wav';
  txtFrasetimeout.Text := ExtractFilePath(Application.ExeName) + 'timeout.wav';

  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(0,'Verso DLL -> ' + cVersao)
  else
    GeraLog(0,'Verso DLL -> Falha');

  nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    GeraLog(0,'Verso OCX -> ' + cVersao)
  else
    GeraLog(0,'Verso OCX -> Falha');

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  nRet: Integer;
  nRet1: Integer;
begin
  if vLib.DriverEnabled then
  begin
    //Desliga se alguma ligao estiver atendida
    cmdDesligarClick(Sender);

    //Interrompe o menu se estiver sendo executado
    if status = True then
    begin
      nRet1:= vLib.MenuAbort(StrToInt(txtPorta.text));
      if nRet1 <> DG_EXIT_SUCCESS then
        Application.MessageBox('Erro ao Finalizar o Menu', 'Exemplo de Menu de Atendimento - Erro', MB_OK,)
    end;

    //Desliga a Placa
    nRet := vLib.ShutdownVoicerLib;

    //Testa se desligou corretamente
    if nRet = DG_EXIT_SUCCESS then
    begin
      lblStatus.Caption := 'Placa finalizada com sucesso';
      GeraLog(StrToInt(txtPorta.Text),'Placa finalizada com sucesso');
    end
    else
      Application.MessageBox('Erro na finalizao. Recomenda-se reiniciar o micro.', 'Erro', MB_OK,);
  end;
end;

procedure TForm1.cmdStartClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Verifica se o driver esta habilitado
  if vlib.DriverEnabled then
    GeraLog(0,'Driver ja inicializado')
  else
  begin
    //Inicializa a placa
    nRet := vlib.StartVoicerLib;
    //Trata o retorno da inicializacao
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));

    //Testa o retorno do StartVoicerLib
    if nRet = DG_EXIT_SUCCESS then
    begin
      GeraLog(0,'VoicerLib Inicializada com Sucesso');
      nTotalPortas := vlib.GetPortsCount ;
      nTotalPlacas := vlib.GetCardsCount ;
      lblStatus1.Caption := 'Nmero Total de Placas: ' + IntToStr(nTotalPlacas) ;
      lblStatus2.Caption := 'Nmero Total de Portas: ' + IntToStr(nTotalPortas) ;
      cmdStart.Enabled := False;
      cmdShutdown.Enabled := True;
    end
    else
      GeraLog(0,'Erro ao inicializar a VoicerLib. Erro-> '+ sReturn);
  end;
end;

procedure TForm1.cmdShutdownClick(Sender: TObject);
var
  nRet : integer;
begin

  //Verifica se o driver esta desabilitado
  if vlib.DriverEnabled then
  begin
    //Desliga a Placa
    nRet:= vlib.ShutdownVoicerLib;

    //Testa se desligou corretamente
    if nRet <> DG_EXIT_SUCCESS then
      GeraLog(0,'Erro na finalizao. Recomenda-se reiniciar o micro.')
    else
    begin
      GeraLog(0,'VoicerLib finalizada com Sucesso!');
      cmdStart.Enabled := True;
      cmdShutdown.Enabled := False;
    end;
  end;
end;

procedure TForm1.GeraLog(nPorta: Integer; sMsg: String);
begin
  try
    memLog.Lines.Add('<' + TimeToStr(Time) + '>' + IntToStr(nPorta) + ' -> ' + sMsg);
  except;
    Application.MessageBox('GeraLog', 'Except', mb_OK);
  end;
end;


procedure TForm1.vLibRingDetected(ASender: TObject; Port: Smallint);
begin
  GeraLog(Port,'Ring.....');
end;

procedure TForm1.vLibPlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet: integer;
begin

  GeraLog(Port, 'OnPlayStop...');

  if (falando_lista=1) then
  begin
    //Desliga a ligao
    nRet:= vLib.HangUp(StrToInt(txtPorta.text));

    //Testa se desligou corretamente
    if nRet = DG_EXIT_SUCCESS then
    begin
      lblStatus.Caption := 'Desligou com sucesso';
      GeraLog(StrToInt(txtPorta.text),'Desligou com sucesso');
      cmdAtender.Enabled := True;
      cmdDesligar.Enabled := False;
    end
    else
    begin
      lblStatus.Caption := 'Erro ao Desligar';
      GeraLog(StrToInt(txtPorta.text),'Erro ao Desligar');
    end;
  end;
end;

procedure TForm1.vLibAfterPickup(ASender: TObject; Port: Smallint);
begin
  GeraLog(Port, 'Atendeu com sucesso..');

  falando_lista := 0;
end;

procedure TForm1.vLibBusyDetected(ASender: TObject; Port: Smallint);
var
  nRet : Integer;
begin
  GeraLog(Port, 'Ocupado..');
  //Desliga porta
  nRet := vlib.HangUp(Port);
  if nRet <> DG_EXIT_SUCCESS then
    GeraLog(Port,'Erro ao desligar')
  else
  begin
    GeraLog(Port,'Desligou com sucesso');
    cmdAtender.Enabled := True;
    cmdDesligar.Enabled := False;
    cmdInterromperClick(ASender);
  end;

end;

procedure TForm1.LeiaMeClick(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);
end;


procedure TForm1.vLibMenu(ASender: TObject; Port: Smallint;
  const OptionSelected: WideString; Status: Smallint);
var
  sMsg: String;
  nRet : Integer;
begin

  cmdReproduzirmenu.Enabled := True;
  cmdInterromper.Enabled := False;
  //Limpa os itens da Lista
  vlib.PlayListClear(StrToInt(txtPorta.Text));
  GeraLog(Port,'Gerou evento de OnMenu');

  case Status of

    msAborted:
    begin
      sMsg:= 'Cancelado pelo MenuAbort';
      GeraLog(Port,sMsg);
    end;

    msRetriesExceeded:
    begin
      sMsg := 'Fim de Menu - Nmero de tentativas excedido';
      Geralog(Port,sMsg);
      //Desliga a ligao
      nRet:= vLib.HangUp(StrToInt(txtPorta.text));

      //Testa se desligou corretamente
      if nRet = DG_EXIT_SUCCESS then
      begin
        sMsg := 'Desligou com sucesso';
        lblStatus.Caption := sMsg ;
        GeraLog(StrToInt(txtPorta.text),sMsg);
        cmdAtender.Enabled := True;
        cmdDesligar.Enabled := False;
      end
      else
      begin
        sMsg := 'Erro ao Desligar';
        lblStatus.Caption := sMsg;
        GeraLog(StrToInt(txtPorta.text),sMsg);
      end;
    end;

    msTimeOut:
    begin
      sMsg := 'Fim de Menu - Limite de Tempo sem Resposta, usurio no digitou nada';
      Geralog(Port,sMsg);

      //Desliga a ligao
      nRet:= vLib.HangUp(StrToInt(txtPorta.text));

      //Testa se desligou corretamente
      if nRet = DG_EXIT_SUCCESS then
      begin
        sMsg :=  'Desligou com sucesso';
        lblStatus.Caption := sMsg;
        GeraLog(StrToInt(txtPorta.text),sMsg);
        cmdAtender.Enabled := True;
        cmdDesligar.Enabled := False;

      end
      else
      begin
        sMsg := 'Erro ao Desligar';
        lblStatus.Caption := sMsg;
        GeraLog(StrToInt(txtPorta.text),sMsg);
      end;
    end;

    msValidOptionDetected:
    begin
      sMsg := 'Fim de Menu - Opo : ' + OptionSelected + ' selecionada';
      Geralog(Port,sMsg);

      case StrToInt(OptionSelected) of

        2://Comercial
        begin
          falando_lista:=1;

          //Para reproducao de mensagem
          vlib.StopPlayFile(StrToInt(txtPorta.text));

          //Limpa a lista de reproducao
          vlib.PlayListClear(StrToInt(txtPorta.text));
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'opcaoselecionada.wav','',10);
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'comercial.wav','',10);

          //Inicia a reproducao da lista
          nRet := vlib.PlayList(StrToInt(txtPorta.text),'');
          if nRet <> DG_EXIT_SUCCESS then
            GeraLog(0,'Comercial - Erro no PlayList: ' + IntToStr(nret))
          else
            GeraLog(0,'Comercial - PlayList executado com sucesso');
        end;

        3://Expedicao
        begin
          falando_lista:=1;
          //Limpa a lista de reproducao
          vlib.PlayListClear(StrToInt(txtPorta.text));
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'opcaoselecionada.wav','',10);
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'expedicao.wav','',10);
          //Inicia a reproducao da lista
          nRet:= vlib.PlayList(StrToInt(txtPorta.text),'');
          if nRet <> DG_EXIT_SUCCESS then
            GeraLog(0,'Expedicao - Erro no PlayList: ' + IntToStr(nret))
          else
            GeraLog(0,'Expedicao - PlayList executado com sucesso');

        end;

        4://Suporte
        begin
          falando_lista:=1;
          //Limpa a lista de reproducao
          vlib.PlayListClear(StrToInt(txtPorta.text));
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'opcaoselecionada.wav','',10);
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'suporte.wav','',10);
          //Inicia a reproducao da lista
          nRet := vlib.PlayList(StrToInt(txtPorta.text),'');
          if nret <> DG_EXIT_SUCCESS then
            GeraLog(0,'Suporte - Erro no PlayList: ' + IntToStr(nret))
          else
            GeraLog(0,'Suporte - PlayList executado com sucesso');

        end;

        else
        begin
          falando_lista:=1;
          //Limpa a lista de reproducao
          vlib.PlayListClear(StrToInt(txtPorta.text));
          vlib.PlayListAdd(StrToInt(txtPorta.text),ptFile,ExtractFilePath(Application.ExeName)+ 'erro.wav','',10);
          //Inicia a reproducao da lista
          nRet := vlib.PlayList(StrToInt(txtPorta.text),'');
          if nRet <> DG_EXIT_SUCCESS then
            GeraLog(0,'Frase Erro - Erro no PlayList: ' + IntToStr(nret))
          else
            GeraLog(0,'Frase Erro - PlayList executado com sucesso');
        end;
      end;
    end;
  else
    Geralog(Port,'OnMenu - Status = ' + IntToStr(Status)+ '...');
  end;

  lblStatus.Caption := sMsg;

  cmdReproduzirmenu.Enabled := True;
  cmdInterromper.Enabled := False;
end;

procedure TForm1.cmdLimpaLogClick(Sender: TObject);
begin
  memLog.Clear;
end;

procedure TForm1.btnEnableClick(Sender: TObject);
var
  nRet,i,j,k : Integer;
begin
  try
    for j:=1 to vlib.GetPortsCount do
    begin
      //Cria thread do protocolo R2D
      nRet := vlib.CreateE1Thread(j);

      case nRet of
        DG_EXIT_SUCCESS:
          GeraLog(j,'Thread E1 iniciada com sucesso');

        DG_ERROR_DRIVER_CLOSED:
          GeraLog(j,'O driver no foi iniciado');

        DG_ERROR_THREAD_ALREADY_RUNNING:
          GeraLog(j,'A thread j havia sido iniciada anteriormente');

        DG_FEATURE_NOT_SUPPORTED:
          GeraLog(j,'Comando enviado para uma placa FXO e no E1');

        DG_ERROR_FIFO_UNAVAILABLE:
          GeraLog(j,'Erro na criao da estrutura de comunicao da thread');

        DG_ERROR_COULD_NOT_CREATE_THREAD:
          GeraLog(j,'Falha na inicializao da thread');

      end;
    end;

    for i:=1 to vlib.GetCardsCount do
    begin
      //Configura o H100 como placa MASTER com sincronismo externo no E1 A (Primeiro E1)
      vlib.SetCardSyncMode(i, SYNC_LINE_A);
      //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
      vlib.SetAlarmMode(i, ALARM_AUTOMATIC_NOTIFY);
    end;

    for k:=1 to vlib.GetPortsCount do
    begin
      //Categoria do Assinante
      vlib.ConfigE1Thread(k, E1CFG_GROUP_II,1);
      //Seta o Bina
      vlib.SetPortID(k, '1121916363');
      //Numero total de digitos a receber
      vlib.ConfigE1Thread(k, E1CFG_MAXDIGITS_RX,4);
      //Status Grupo B
      vlib.ConfigE1Thread(k, E1CFG_GROUP_B,1);
      //Em ligacoes de entrada, pede bina apos o 2 digito
      vlib.ConfigE1Thread(k, E1CFG_SEND_ID_AFTERDIGIT,2);
    end;

  except
    Application.MessageBox('Erro na Criao das Threads E1', 'Except', mb_OK);
  end;

end;

procedure TForm1.btnDisableClick(Sender: TObject);
var
  i : Integer;
begin
  try
    for i:=1 to vlib.GetPortsCount do
    begin
      //Destroi as Threads
      if vlib.DestroyE1Thread(i) <> DG_EXIT_SUCCESS then
        GeraLog(i,'Erro ao destruir Thread E1')
      else
        GeraLog(i,'Fechou Thread E1') ;
    end;

    txtPorta.Enabled := True;

  except
    Application.MessageBox('Erro ao Destruir as Threads E1', 'Except', mb_OK);
  end;

end;

procedure TForm1.vlibE1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin

  case AlarmCode of
    ALARM_RSLIP:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo) ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Escorregamento OFF');
    end;

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_RESERVED:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        GeraLog(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;

end.
